#!/bin/sh

MMC=$(dmesg|grep "new DDR MMC"|tail -1|awk '{a=gsub(":", "", $3); print $3}')
MMC_NR=$(echo $MMC|awk '{a=gsub("mmc", "", $1); print $1}')
MMC_DEV=/dev/mmcblk$MMC_NR
SDHC=$(dmesg |grep "$MMC.*usdhc"|awk '{print $7}')

reset_mmc () {
    sleep 2
    echo $SDHC > /sys/bus/platform/drivers/sdhci-esdhc-imx/unbind
    sleep 2
    echo $SDHC > /sys/bus/platform/drivers/sdhci-esdhc-imx/bind
    sleep $1
}

/home/root/recovery-tool/PWP_Check $MMC_DEV | tee /tmp/log_check

CH_ENV=$(cat /tmp/log_check |grep "This eMMC doesn't present PWP Risk.")

if [ -n "$CH_ENV" ]; then
    echo "Recovering standard u-boot env"
    fw_setenv bootcmd 'echo  "" ; echo  "" ; echo  "" ; echo  "" ; echo  "This eMMC does not present PWP Risk." ; echo  "" ; echo  "" ; echo  "" ; echo  "" ; echo  "Boot will continue with Easy Installer in 10 seconds." ; sleep 10 ; env default -a ; saveenv ; run distro_bootcmd; usb start ; setenv stdout serial,vidconsole; setenv stdin serial,usbkbd'
    reboot
fi

START=$(cat /tmp/log_check |grep "This eMMC is at risk of Forced Read Only Mode.")
FAIL_ATTEMPT=$(cat /tmp/log_check |grep "The FFU repair process has not been executed correctly,")

if [ -n "$START" -o -n "$FAIL_ATTEMPT" ]; then
    echo "Running automatically FFU Repair Tool:"

    cd /home/root/recovery-tool 

    ./FFU_Repair_Tool $MMC_DEV
    reset_mmc 6
    ./FFU_Repair_Tool $MMC_DEV
    reset_mmc 6
    ./FFU_Repair_Tool $MMC_DEV > /tmp/log_check
    reset_mmc 6
fi

